From em@dce.ie Wed Jan  2 20:42:48 1991
From: em@dce.ie (Eamonn McManus)
Newsgroups: comp.dcom.modems
Subject: Re: comp.dcom.modems lexicon
Date: 2 Jan 91 18:21:27 GMT
Organization: Datacode Communications Ltd, Dublin, Ireland
Supersedes: <lexifymylove@dce.ie>

[Since there don't seem to have been many Frequently Asked Questions recently
 I'm thinking of changing the frequency of this posting to monthly instead
 of fortnightly.  Comments are welcome.]

$Id: lexicon,v 0.2 90/12/03 18:27:26 em Exp $

Comp.dcom.modems lexicon, by Eamonn McManus <em@dce.ie>.  Contributions by:
  Charles Bryant <ch@dce.ie>.
  Ronald S H Khoo <ronald@robobar.co.uk>
  David Lesher <wb8foz@mthvax.cs.miami.edu>
  Chip Rosenthal <chip@chinacat.unicom.com>

This lexicon is intended to provide a basic introduction to terms used in
modem technology.  In the interests of brevity, some technical details and
qualifications are omitted.  Corrections, additions, and suggestions are
welcome; send them to <em@dce.ie>.

This document is not copyrighted and may be used freely.

Words in angle brackets, like <this>, denote cross-references.  The
following terms are defined or discussed here:
  Asynchronous, AT commands, back channel, baud, Bell standards, bps,
  carrier, CCITT, compression, CTS, DCD, DCE, DSR, DTE, DTMF, DTR, error
  correction, external modem, fall back, flow control, four wire, full
  duplex, half duplex, Hayes, internal modem, leased line, MNP, modulation,
  parallel, PEP, PTT, RTS, serial, speed buffering, spoofing, synchronous,
  Trailblazer, uucp, V series, window, XMODEM, XON/XOFF, ZMODEM.

---

Asynchronous.  Used of a <serial> connection where each byte is sent
  independently.  The start and end of a byte are indicated by separate bits
  so each byte takes 10 bits to transmit.  See <synchronous>.

AT commands.  See <Hayes>.  (Unrelated to the PC/AT.)

Back channel.  A slow communications channel provided in the reverse
  direction to the main channel, in <V.23> for example.

Baud.  A unit of communication speed, defined as signalling elements per
  second.  Not the same as bps since sometimes each signalling element 
  carries several bits.  (There is no such thing as a 9600 baud modem,
  for instance.)  Terminals always have baud the same as bps.

Bell standards.  <Modulation> techniques used in North America.  Bell 103
  is a 300bps standard; Bell 212 is 1200bps.  Not allowed in some European
  countries.  See <V series>.

Bps.  Bits per second.  See <baud>.

Carrier.  Roughly speaking, the tones a modem sends when it is not sending
  data.  Data are then variations in these tones.  When the remote modem
  stops emitting carrier, the local modem can assume it has hung up, unless
  the local modem is now the sending party in a <half duplex> connection.

CCITT.  A French acronym for the International Telegraph and Telephone
  Consultative Committee, which sets standards for telephone communication
  among other things.  Their standards (or `recommendations' as they have
  it) are published every so often in a set of `fascicles', whose colour
  varies with the year.  The current set is the `blue books' published in
  1988.  The standards are copyrighted, so they are not available
  electronically.  You should be able to find them at any good
  engineering library.  See <V series>.

Compression.  Reduction of the size of data by exploiting redundancy.  Many
  modern modems incorporate use <MNP5> or <V.42 bis> to compress data
  before they are sent over the phone line.  For this to be effective, the
  modem must be fed data at a higher speed than the phone line speed.

  Compression is most useful for interactive sessions in the modem.  If you
  are sending files, compressing them on the computer before sending is
  usually more effective.  In this case, make sure that the modem is not
  also trying to compress, because already-compressed data will become
  bigger if re-compressed.

  For compression to work, it is essential that the data are sent over an
  error-free link.  Otherwise the modems could get out of sync and
  hopelessly garble the data.  Since common <error correction> protocols are
  <synchronous>, there is usually a throughput gain there as well.

  Manufacturer claims that MNP5 provides a 2:1 reduction in size, or that
  V.42 bis provides 4:1, should be taken with a grain of salt.  They are
  only true for suitable data.  See <MNP5> and <V.42 bis>.

CTS.  Clear to send.  A signal from <DCE> to <DTE>.  Typically used for
  <flow control>.

DCD.  Data carrier detect.  A signal from <DCE> to <DTE>, indicating that a
  <carrier> tone is being heard from the remote modem.  See <DSR>.

DCE.  Data circuit-terminating equipment.  Whatever is connected to a phone
  line.  Effectively, a modem.

DSR.  Data set ready.  A signal from <DCE> to <DTE>, indicating that a
  connection is in progress.  For <half duplex> connections, DSR will be on
  during the entire session, while <CD> will be on only when the modem is
  receiving.

DTE.  Data terminal equipment.  The computer or terminal that talks to a
  modem locally.

DTMF.  Dual tone multiple frequency.  The standard method for tone dialling.

DTR.  Data terminal ready.  A signal from <DTE> to <DCE>.  Sometimes used
  for <flow control>, though <RTS> is more usual nowadays.  Typically,
  dropping DTR will cause the modem to hang up.

Error correction.  Communication between the modems to ensure that the data
  sent by one end are the same as those received by the other, even in the
  presence of noise on the line.  Typically this is done by adding
  checksums to the data.  If the received data don't match their checksum
  the receiving modem asks for them to be sent again.

  Like <compression>, error correction is most useful for interactive use.
  When sending files, it is generally best to let the computers at each end
  do the correction, using a protocol like Kermit or <uucp>.  However, the
  ability of <MNP4> and <V.42> to send data <synchronously> may make it
  worthwhile to use them.  See also <spoofing>.

External modem.  See <internal modem>.

Fall back.  The ability of a modem to operate at a lower speed than its
  maximum, used either for compatibility with a different type of modem
  (e.g. <V.22 bis> can fall back to <V.22>) or to reduce the number of
  errors over a link that cannot carry the fastest speed.

Flow control.  Ensuring that a unit, whether modem or computer, is not
  supplied with more data than it can cope with.  The unit must have some
  way to signal to the data source to stop sending.  Ideally, every unit on
  the communication path should have a way to manage flow control with its
  peers; otherwise if available buffer space is exceeded some data may be
  lost.

  Between <DTE> and <DCE> the possibilities are <RTS>/<CTS> and <XON/XOFF>.
  Between two <DCE>s <XON/XOFF> is the only possibility.  However, if a
  protocol such as <MNP> is being run between the modems, this will
  contain provision for flow control.  If you can guarantee that the <DTE>s
  will always be able to accept data, you should not need flow control
  between the <DCE>s.

Four wire.  A <leased line> with separate connections for transmitting data
  in each direction.

Full duplex.  Able to send data in both directions at once.

Half duplex.  Able to send data in only one direction at a time.

Hayes.  Modem manufacturer.  The `Hayes command set' is supported by most
  modern modems.  Hayes commands look like ATD1234 (dial 1234) or ATA
  (answer the phone).  The commands for simple things like this are fairly
  standard, but more complex things tend to be manufacturer-specific.  A
  <CCITT> standard for Hayes commands is in preparation.

Internal modem.  A modem card that slots into your computer, as opposed to
  an external modem, which is a separate unit.  Internal modems are usually
  cheaper but they have some disadvantages.  An external modem can be used
  with any computer; it will have diagnostic lights to see what is going
  on; and it means the phone line is further from your PC and so less likely
  to conduct lightning strikes into it.

Leased line.  A permanent point-to-point connection rented from the phone
  company.

MNP.  Microcom Network Protocols.  A set of modem-to-modem protocols that
  provide <error correction> and <compression>.  The commonly encountered
  ones are these:

  MNP2.  <Error correction> using <asynchronous> transmission.
  MNP3.  <Error correction> using <synchronous> transmission between the
    modems (the <DTE> interface is still <asynchronous>).  Since each
    eight-bit byte takes eight rather than ten bits to transmit there is
    scope for a 20% increase in throughput.  Unfortunately the MNP3
    protocol overhead is rather high so this increase is not realised.
  MNP4.  Introduces `data phase optimisation', which improves on the rather
    inefficient protocol design of MNP2 and MNP3.  <Synchronous> MNP4 comes
    closer to achieving the 20% throughput increase mentioned above.
  MNP5.  Simple data compression.  Dynamically arranges for commonly
    occurring characters to be transmitted with fewer bits than rare
    characters.  It takes account of changing character frequencies as it
    runs.  Also encodes long runs of the same character specially.  Typically
    compresses text by 35%; with 20% for MNP4 this reduces data by almost
    50%.

Modulation.  Converting a data stream into sounds to be sent down a phone
  line.  The opposite is demodulation.  `Modem' stands for modulator/
  demodulator.

Parallel.  Sending several bits at a time, usually 8, each over a separate
  wire.  Some modems have a parallel connection from <DTE> to <DCE>.

PEP.  A proprietary <modulation> technique devised by Telebit and used in
  their Trailblazer modems.  It can achieve throughput of 9600bps or
  better, and is reported to be more resilient than <V.32>.  However, it is
  <half duplex> with a long <turnaround time>, so for file transfer it
  generally has to be used with protocol <spoofing>.  Trailblazers can
  spoof <uucp>, Kermit, and Z-modem, among other things.

PTT.  General term for the national organisation(s) in charge of telephone
  and postal communications.

RTS.  Request to send.  A signal from <DTE> to <DCE>.  In modern modems,
  this is generally used for <flow control>; when RTS is off the modem will
  not send data to the terminal.

Serial.  Sending one bit at a time.  Opposite of <parallel>.

Speed buffering.  Early modems had very simple hardware which modulated
  data from the terminal directly onto the phone line.  This meant that the
  terminal speed and the line speed had to be the same.  Modern modems
  allow them to be different (speed buffering), but unfortunately the old
  assumption is wired into many communications programs, so modems also
  have to provide the ability to change the terminal speed to the same as
  the line speed when a connection is established.

Spoofing.  Protocol spoofing is used by Trailblazers (see <PEP>).  The
  modem knows what protocol you are using to transfer files to the far end.
  It pretends to be the remote computer and acknowledges the local data as
  soon as it gets them.  The two Trailblazers then conspire to get the data
  safely to the far end.

Synchronous.  Used of a <serial> connection where bytes are sent in a
  continuous stream.  Some sort of protocol is needed to flag the case
  where no bytes are available to be sent.

Trailblazer.  See <PEP>.

Turnaround time.  The time taken in a <half duplex> link to reverse the
  direction of communication.

uucp.  Unix-to-Unix copy.  This is the name of a Unix command, but it is
  now also used to refer to the protocols used by it to transfer files
  between Unix machines.  There are a number of such protocols, and the two
  machines choose between the ones supported by each.  Free implementations
  also exist for VMS and MS-DOS.  The newsgroup comp.mail.uucp may be more
  appropriate for discussions.

V series.  A set of standards published by the <CCITT> for `Data
  Communication over the Telephone Network'.  The following standards
  describe the important <modulation> techniques:

  V.21: 300bps.
  V.22: 1200bps, with <fall back> to 600bps.
  V.22 bis: 2400bps, with <fall back> to V.22.
  V.23: 1200bps with 75bps <back channel>, with <fall back> to 600bps/75bps.
  V.29: 9600bps <half duplex> or <four wire> (used by FAX) with <fall back>
    to 7200bps and 4800bps.
  V.32: 9600bps with <fall back> to 4800bps.
  V.32 bis: 14400bps with <fall back> to 12000bps, 9600bps, 7200bps and
    4800 bps.

  Other standards you may encounter:

  V.24: connection between <DCE> and <DTE>.  Effectively the same as RS232,
    though V.24 only specifies the meaning of the signals, not the
    connector nor the voltages used.
  V.25 bis: a cryptic command language for modems.
  V.42: <error correction> with <asynchronous> to <synchronous> conversion.
  V.42 bis: data <compression> using a Lempel-Ziv related technique, which
    detects frequently occurring character strings and replaces them with
    tokens.  This is similar to Unix compress.  Typical compression for
    text is 50% or better; with nearly 20% gain from <synchronous>
    conversion this gives reduces transmission time by almost 60%.

Window.  Most protocols divide the data to be sent into `packets'.
  To eliminate delays several packets may be sent before any one is
  acknowledged.  If this is allowed by a protocol, the window is the
  number of packets that can be sent before an acknowledgement is
  received.

XMODEM.  A primitive file-transfer protocol.  It has the property that
  files must be a multiple of 128 bytes long.  It is <half duplex> so it
  performs badly on fast modems.

XON/XOFF.  A method of <flow control>.  The XOFF character (ASCII 19) is
  sent to stop further characters, and XON (ASCII 17) is sent to resume
  them.  This method is inferior to hardware flow control using <RTS> and
  <CTS>, since it means that XON and XOFF characters cannot be freely used
  in the data.

ZMODEM.  A file-transfer protocol.

